# pirpl web server.  Outputs contents of $WEB_FILE and parses commands
# from the browser, putting them in $CMD_FILE.  Commands are of the form:
# 
#   cmd=@command@
# 
# somewhere in the string sent to the server - typically in the GET.
# 
# In this case, "command" will be written to $CMD_FILE.  if the command
# is "die" the program exits.
# 
# Obviously this is not a real web server, so images and other content you
# might want to put on the page have to be served from somewhere else.
#
# DO NOT make this server publicly accessible.  Who knows what sort of 
# horrendous security flaws lurk within?

if [[ "$1" = "" || ! -f "$1" ]]; then
	echo "Usage: $0 <config file>"
	exit 1
fi
PIRPL_SERVER_CONF="$1"


. "$PIRPL_SERVER_CONF"

while [ 1 ]; do
	# Wait for web page to appear
	while [[ ! -e "$WEB_FILE" ]]; do
		sleep 1
	done

	web_out=$(<"$WEB_FILE")
	return=$(printf "HTTP/1.1 200 OK\r\n\r\n$web_out" |nc -l $SERVER_PORT)
	if [[ $return =~ .*cmd=.* ]]; then
		command=$(expr "$return" : '.*cmd=@\(.*\)@.*')
	
		if [[ "$command" = "die" ]]; then
			break
		elif [[ "$command" != "" ]]; then
			rm "$CMD_FILE" 2>/dev/null
			echo "$command" > "$CMD_FILE"
		fi
	fi
done
exit 0
